#include<bits/stdc++.h>
using namespace std;

unsigned long long najv,cur;
int N;
int x_koord[1000008];
int y_koord[1000008];
int x_koord2[1000008];
int y_koord2[1000008];
int x,y;

int off[]={0,1,-1,2,-2};

int main(){
    scanf("%d",&N);
    for(int i=0;i<N;i++)
        scanf("%d %d",x_koord+i,y_koord+i);
    printf("0\n");
    for(int l=2;l<=N;l++){
        for(int i=0;i<l;i++){
            x_koord2[i]=x_koord[i];
            y_koord2[i]=y_koord[i];
        }
        sort(x_koord2,x_koord2+l);
        sort(y_koord2,y_koord2+l);
        najv=0;
        for(int a=0;a<3;a++){
            if(l/2+off[a]<0||l/2+off[a]>=l) continue;
            for(int b=0;b<3;b++){
                if(l/2+off[b]<0||l/2+off[b]>=l) continue;
                x=x_koord2[l/2+off[a]];
                y=y_koord2[l/2+off[b]];
                cur=0;
                for(int j=0;j<l;j++)
                    cur+=abs(x-x_koord[j])*abs(y-y_koord[j]);
                if(cur>najv) najv=cur;
            }
        }
        printf("%llu\n",najv%1000000007llu);
    }
    return 0;
}